﻿using Chapter1.Version2;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter1
{
    public enum Planet
    {
        // Explicitly assign values.
        // Default starts at 0 otherwise.
        Mercury = 1,
        Venus = 2,
        Earth = 3,
        Mars = 4,
        Jupiter = 5,
        Saturn = 6,
        Neptune = 7,
        Uranus = 8
        // First edition included Pluto.
    }

    public struct ObservationData
    {
        private Planet whichPlanet; //what am I looking at?
        private double magnitude; // perceived brightness.
    }

    namespace Version2
    {
        public enum Planet
        {
            None = 0,
            Mercury = 1,
            Venus = 2,
            Earth = 3,
            Mars = 4,
            Jupiter = 5,
            Saturn = 6,
            Neptune = 7,
            Uranus = 8
        }

        public struct ObservationData
        {
            Planet whichPlanet; //what am I looking at?
            double magnitude; // perceived brightness.

            ObservationData(Planet target,
              double mag)
            {
                whichPlanet = target;
                magnitude = mag;
            }
        }

        [Flags]
        public enum Styles
        {
            None = 0,
            Flat = 1,
            Sunken = 2,
            Raised = 4,
        }
    }

    public struct LogMessage
    {
        private int ErrLevel;
        private string msg;
    }

    namespace Sample7
    {
        public struct LogMessage
        {
            private int ErrLevel;
            private string msg;

            public string Message
            {
                get => msg ?? string.Empty;
                set => msg = value;
            }
        }
    }
    class Item05
    {
        public static void Tests()
        {
            Planet sphere = new Planet();
            var anotherSphere = default(Planet);
            Planet sphere2 = Planet.Mars;

            ObservationData d = new ObservationData();

            Styles flag = Styles.Sunken;
            if ((flag & Styles.Flat) != 0) // Never true if Flat == 0.
                DoFlatThings();

            LogMessage MyMessage = new LogMessage();
        }

        private static void DoFlatThings()
        {
            throw new NotImplementedException();
        }
    }
}
