﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter3
{
    public class WorkerClass
    {
        public event EventHandler<EventArgs> RaiseProgress;
        private object syncHandle = new object();

        public void DoWork()
        {
            for (int count = 0; count < 100; count++)
            {
                lock (syncHandle)
                {
                    System.Threading.Thread.Sleep(100);
                    progressCounter++;
                    RaiseProgress?.Invoke(this, EventArgs.Empty);
                }
            }
        }

        public void DoWork2()
        {
            for (int count = 0; count < 100; count++)
            {
                lock (syncHandle)
                {
                    System.Threading.Thread.Sleep(100);
                    progressCounter++;
                }
                RaiseProgress?.Invoke(this, EventArgs.Empty);
            }
        }


        private int progressCounter = 0;
        public int Progress

        {
            get
            {
                lock (syncHandle)
                    return progressCounter;
            }
        }
    }

    public class Item32
    {
        static void engine_RaiseProgress(object sender, EventArgs e)
        {
            WorkerClass engine = sender as WorkerClass;
            if (engine != null)
                Console.WriteLine(engine.Progress);
        }

        private object syncHandle = new object();
        private int progressCounter;

        public void DoWork()
        {
            for (int count = 0; count < 100; count++)
            {
                lock (syncHandle)
                {
                    System.Threading.Thread.Sleep(100);
                    progressCounter++;
                }
                engine_RaiseProgress(this, EventArgs.Empty);
            }
        }


        public static void Tests()
        {

        }
    }
}
